Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_RB_Tree_Node Class Template Reference

Implements a node in a Red-Black Tree ADT. More...

`#include <RB_Tree.h>`

Inheritance diagram for ACE_RB_Tree_Node:

[legend]
Collaboration diagram for ACE_RB_Tree_Node:

[legend]
List of all members.

## Public Methods
| ACE_RB_Tree_Node (const EXT_ID &k, const INT_ID &t)
| Constructor. More...
| ~ACE_RB_Tree_Node (void)
| Destructor. More...
EXT_ID & | key (void)
| Key accessor. More...
INT_ID & | item (void)
| Item accessor. More...
void | color (RB_Tree_Node_Color c)
| Set color of the node. More...
RB_Tree_Node_Color | color (void)
| Get color of the node. More...
ACE_RB_Tree_Node< EXT_ID, INT_ID > * | parent (void)
| Accessor for node's parent pointer. More...
void | parent (ACE_RB_Tree_Node< EXT_ID, INT_ID > *p)
| Mutator for node's parent pointer. More...
ACE_RB_Tree_Node< EXT_ID, INT_ID > * | left (void)
| Accessor for node's left child pointer. More...
void | left (ACE_RB_Tree_Node< EXT_ID, INT_ID > *l)
| Mutator for node's left child pointer. More...
ACE_RB_Tree_Node< EXT_ID, INT_ID > * | right (void)
| Accessor for node's right child pointer. More...
void | right (ACE_RB_Tree_Node< EXT_ID, INT_ID > *r)
| Mutator for node's right child pointer. More...
## Private Attributes
EXT_ID | k_
| The key. More...
INT_ID | t_
| The item. More...
RB_Tree_Node_Color | color_
| Color of the node. More...
ACE_RB_Tree_Node< EXT_ID, INT_ID > * | parent_
| Pointer to node's parent. More...
ACE_RB_Tree_Node< EXT_ID, INT_ID > * | left_
| Pointer to node's left child. More...
ACE_RB_Tree_Node< EXT_ID, INT_ID > * | right_
| Pointer to node's right child. More...

## Detailed Description

### template<class EXT_ID, class INT_ID>
class ACE_RB_Tree_Node< EXT_ID, INT_ID >

Implements a node in a Red-Black Tree ADT.

## Constructor & Destructor Documentation

template<class EXT_ID, class INT_ID>
ACE_RB_Tree_Node< EXT_ID, INT_ID >::ACE_RB_Tree_Node | ( | const EXT_ID & | k,
|  | const INT_ID & | t
| ) |

| Constructor.

template<class EXT_ID, class INT_ID>
ACE_RB_Tree_Node< EXT_ID, INT_ID >::~ACE_RB_Tree_Node | ( | void |  | ) |

| Destructor.

## Member Function Documentation

template<class EXT_ID, class INT_ID>
ACE_INLINE ACE_RB_Tree_Node_Base::RB_Tree_Node_Color ACE_RB_Tree_Node< EXT_ID, INT_ID >::color | ( | void |  | ) |

| Get color of the node.

template<class EXT_ID, class INT_ID>
ACE_INLINE void ACE_RB_Tree_Node< EXT_ID, INT_ID >::color | ( | ACE_RB_Tree_Node_Base::RB_Tree_Node_Color | c | ) |

| Set color of the node.

template<class EXT_ID, class INT_ID>
ACE_INLINE INT_ID & ACE_RB_Tree_Node< EXT_ID, INT_ID >::item | ( | void |  | ) |

| Item accessor.

template<class EXT_ID, class INT_ID>
ACE_INLINE EXT_ID & ACE_RB_Tree_Node< EXT_ID, INT_ID >::key | ( | void |  | ) |

| Key accessor.

template<class EXT_ID, class INT_ID>
ACE_INLINE void ACE_RB_Tree_Node< EXT_ID, INT_ID >::left | ( | ACE_RB_Tree_Node< EXT_ID, INT_ID > * | l | ) |

| Mutator for node's left child pointer.

template<class EXT_ID, class INT_ID>
ACE_INLINE ACE_RB_Tree_Node< EXT_ID, INT_ID > * ACE_RB_Tree_Node< EXT_ID, INT_ID >::left | ( | void |  | ) |

| Accessor for node's left child pointer.

template<class EXT_ID, class INT_ID>
ACE_INLINE void ACE_RB_Tree_Node< EXT_ID, INT_ID >::parent | ( | ACE_RB_Tree_Node< EXT_ID, INT_ID > * | p | ) |

| Mutator for node's parent pointer.

template<class EXT_ID, class INT_ID>
ACE_INLINE ACE_RB_Tree_Node< EXT_ID, INT_ID > * ACE_RB_Tree_Node< EXT_ID, INT_ID >::parent | ( | void |  | ) |

| Accessor for node's parent pointer.

template<class EXT_ID, class INT_ID>
ACE_INLINE void ACE_RB_Tree_Node< EXT_ID, INT_ID >::right | ( | ACE_RB_Tree_Node< EXT_ID, INT_ID > * | r | ) |

| Mutator for node's right child pointer.

template<class EXT_ID, class INT_ID>
ACE_INLINE ACE_RB_Tree_Node< EXT_ID, INT_ID > * ACE_RB_Tree_Node< EXT_ID, INT_ID >::right | ( | void |  | ) |

| Accessor for node's right child pointer.

## Member Data Documentation

template<class EXT_ID, class INT_ID>
RB_Tree_Node_Color ACE_RB_Tree_Node::color_`[private]`

| Color of the node.

template<class EXT_ID, class INT_ID>
EXT_ID ACE_RB_Tree_Node::k_`[private]`

| The key.

template<class EXT_ID, class INT_ID>
ACE_RB_Tree_Node<EXT_ID, INT_ID>* ACE_RB_Tree_Node::left_`[private]`

| Pointer to node's left child.

template<class EXT_ID, class INT_ID>
ACE_RB_Tree_Node<EXT_ID, INT_ID>* ACE_RB_Tree_Node::parent_`[private]`

| Pointer to node's parent.

template<class EXT_ID, class INT_ID>
ACE_RB_Tree_Node<EXT_ID, INT_ID>* ACE_RB_Tree_Node::right_`[private]`

| Pointer to node's right child.

template<class EXT_ID, class INT_ID>
INT_ID ACE_RB_Tree_Node::t_`[private]`

| The item.

The documentation for this class was generated from the following files:

- RB_Tree.h
- RB_Tree.cpp
- RB_Tree.i